<?php

//---------------------------------------------
//load cube settings
//---------------------------------------------
    
if (file_exists('cube/3dcube.xml'))
{
    $xml = simplexml_load_file('cube/3dcube.xml');
}
else
{
    die('settings file is missing');
}

// path to cache WITHOUT trailing slash
$path_to_cache = 'cache';

//---------------------------------------------
// prepare flickr request
//---------------------------------------------

// build the API URL to call
$params = array(
	'api_key'	=> 'REPLACE_WITH_YOUR_API_KEY',
	'method'	=> 'flickr.photos.getRecent',
	'per_page' => 10,
	'format'	=> 'php_serial',
);

$encoded_params = array();

foreach ($params as $k => $v)
{
	$encoded_params[] = urlencode($k).'='.urlencode($v);
}

$request = "http://api.flickr.com/services/rest/?".implode('&', $encoded_params);

//---------------------------------------------
// use cURL to send the request
//---------------------------------------------

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $request);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 0);
$response = curl_exec($ch);
curl_close($ch);

$rsp_obj = unserialize($response);

if ($rsp_obj['stat'] != 'ok')
{
  echo "Call failed!";
  exit;
}

//---------------------------------------------
// parse items
//---------------------------------------------

// create an empty array
$images = array();

for ($i = 0; $i < count($rsp_obj['photos']['photo']); $i++) {

  $file = $rsp_obj['photos']['photo'][$i];
  $farm = $file['farm'];
  $server = $file['server'];
  $id = $file['id'];
  $secret = $file['secret'];

  // http://farm{farm-id}.static.flickr.com/{server-id}/{id}_{secret}_m.jpg
  $img_url = 'http://farm'.$farm.'.static.flickr.com/'.$server.'/'.$id.'_'.$secret.'_m.jpg';
      
  // we will cache the image on the server
  if (!file_exists($path_to_cache.'/'.md5($img_url).'.jpg'))
  {
    // store the image on the server (we will use the md5 hash as filename)
    $fp = fopen($path_to_cache.'/'.md5($img_url).'.jpg', 'w');
    
    // use cURL to get the image
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $img_url);
    curl_setopt($ch, CURLOPT_FILE, $fp);
    curl_exec($ch);
    curl_close($ch);

    fclose($fp);
  }
        
  // create new item
  $item = array (
    'ImagePath' 			=>		$path_to_cache.'/'.md5($img_url).'.jpg',
    'ImageLink'				=>		'',
    'ImageLinkTarget' =>		'_blank',
    'Content1'				=>		'',
    'Content2'				=>		'',
    'JSFunction'			=>		''
  );
  
  // add the item to the array
  array_push($images, $item);
}

//---------------------------------------------
// add entries to generated config file
//---------------------------------------------

foreach ($images as $entry)
{
	$tag = $xml->Images->addChild('Image');
	foreach ($entry as $key => $value)
	{
		$tag->addChild($key, '<![CDATA['.htmlentities($value).']]>');
	}
}

print_r(html_entity_decode($xml->asXML()));

?>